diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
index b319d7bf8..ddab17cb8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
@@ -6,8 +6,11 @@ import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.block.model.BlockModelPiston;
 import net.minecraft.client.render.block.model.BlockModelPistonHead;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
@@ -28,7 +31,7 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
     }
 
     @Override
-    public void doRender(Tessellator tessellator, TileEntityMovingPistonBlock tileEntity, double x, double y, double z,
+    public void doRender(TessellatorGeneral tessellator, TileEntityMovingPistonBlock tileEntity, double x, double y, double z,
                          float partialTick) {
         Block<?> block = Blocks.getBlock(tileEntity.getMovedId());
         if (block != null && tileEntity.getProgress(partialTick) < 1.0F) {
@@ -36,11 +39,11 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
                 this.container = new BlocksContainer(tileEntity.worldObj);
             }
             TilePos tileEntPos = new TilePos(tileEntity.x, tileEntity.y, tileEntity.z);
-            TextureRegistry.blockAtlas.bind();
+            TextureRegistry.worldAtlas.bind();
             Lighting.disable();
-            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glDisable(GL11.GL_CULL_FACE);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.disableState(State.CULL_FACE);
             if (this.mc.isAmbientOcclusionEnabled()) {
                 GL11.glShadeModel(GL11.GL_SMOOTH);
             } else {
@@ -79,10 +82,10 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
             TileEntity movedEntity = tileEntity.getMovedEntity();
             TileEntityRenderer<TileEntity> renderer = TileEntityRenderDispatcher.instance.getRenderer(movedEntity);
             if (renderer != null) {
-                GL11.glPushMatrix();
-                GL11.glTranslatef(tileEntity.getXOff(partialTick), tileEntity.getYOff(partialTick), tileEntity.getZOff(partialTick));
+                GLRenderer.pushFrame();
+                GLRenderer.modelM4f().translate(tileEntity.getXOff(partialTick), tileEntity.getYOff(partialTick), tileEntity.getZOff(partialTick));
                 renderer.doRender(tessellator, movedEntity, x, y, z, partialTick);
-                GL11.glPopMatrix();
+                GLRenderer.popFrame();
             }
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 2f6bcfcc5..d88f1ddb7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -8,7 +8,9 @@ import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.font.SF;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.helper.Colors;
@@ -23,9 +25,8 @@ import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Math;
 import org.joml.primitives.AABBd;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
 import java.util.ArrayList;
@@ -47,50 +48,40 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
     }
 
     @Override
-    public void doRender(final @NotNull Tessellator t, final @NotNull TileEntitySign tileEntity, final double x, final double y, final double z, final float partialTick) {
+    public void doRender(final @NotNull TessellatorGeneral t, final @NotNull TileEntitySign tileEntity, final double x, final double y, final double z, final float partialTick) {
         final Block<?> block = tileEntity.getBlock();
         if (block == null || !(block.getLogic() instanceof BlockLogicSign sign))
             return; // Check to make sure the block for the entity is present before rendering, some edge cases have the tile entity loaded before the block data and can cause a crash
 
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glPushMatrix();
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.pushFrame();
 
         final StaticEntityModel model;
 
         final float scale = 2 / 3f * 1 / 16f;
         final float height;
-        GL11.glTranslatef((float) x + 0.5F, (float) y, (float) z + 0.5F);
+        GLRenderer.modelM4f().translate((float) x + 0.5F, (float) y, (float) z + 0.5F);
         final int meta = tileEntity.getBlockMeta();
         if (sign.isFreeStanding) {
             final float angle = (float) ((meta & BlockLogicSign.MASK_SIDE) * 360) / 16F;
-            GL11.glRotatef(-angle, 0.0F, 1.0F, 0.0F);
+            GLRenderer.modelM4f().rotateY(Math.toRadians(-angle));
             model = getModel("post");
             height = 20;
         } else {
-            final float angle;
-            switch (meta & BlockLogicSign.MASK_SIDE) {
-                case BlockLogicSign.SIDE_NORTH:
-                    angle = 180F;
-                    break;
-                case BlockLogicSign.SIDE_SOUTH:
-                    angle = 0.0F;
-                    break;
-                case BlockLogicSign.SIDE_WEST:
-                    angle = 90F;
-                    break;
-                case BlockLogicSign.SIDE_EAST:
-                default:
-                    angle = -90F;
-                    break;
-            }
-            GL11.glRotatef(-angle, 0.0F, 1.0F, 0.0F);
-            GL11.glTranslatef(0, 0, -11 * scale);
+            final float angle = switch (meta & BlockLogicSign.MASK_SIDE) {
+                case BlockLogicSign.SIDE_NORTH -> 180F;
+                case BlockLogicSign.SIDE_SOUTH -> 0.0F;
+                case BlockLogicSign.SIDE_WEST -> 90F;
+                default -> -90F;
+            };
+            GLRenderer.modelM4f().rotateY(Math.toRadians(-angle));
+            GLRenderer.modelM4f().translate(0, 0, -11 * scale);
             model = getModel("wall");
             height = 13;
         }
 
-        GL11.glPushMatrix();
-        GL11.glScalef(scale, scale, -scale);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().scale(scale, scale, -scale);
         final int colorSign;
         if (Block.hasLogicClass(block, BlockLogicSignPainted.class)) {
             final DyeColor c = ((IPainted) block.getLogic()).fromMetadata(meta);
@@ -101,45 +92,41 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
 //            colorSign = 0xa57319;
             colorSign = 0x695e43;
         }
-        GL11.glDisable(GL11.GL_BLEND);
-        model.render(t);
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glPopMatrix();
+        GLRenderer.disableState(State.BLEND);
+        model.render();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.popFrame();
 
         // Render overlay
-        GL11.glPushMatrix();
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glTranslatef(0 * scale, height * scale, 1.05f * scale);
-        GL11.glNormal3f(0, 0, 1);
-        GL11.glDepthMask(false);
-        GL11.glColor4f(1, 1, 1, 1);
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.modelM4f().translate(0 * scale, height * scale, 1.05f * scale);
+//        GL11.glNormal3f(0, 0, 1);
+        GLRenderer.setDepthMask(false);
+        GLRenderer.setColor4f(1, 1, 1, 1);
         final EnumSignPicture picture = tileEntity.getPicture();
         if (picture != EnumSignPicture.NONE)
             drawTexturedModalRect(1, 0.5, colorSign, TextureRegistry.getTexture(picture.getTextureKey()));
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glPopMatrix();
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.popFrame();
 
         // Render text
         final FontRenderer sr = getFont();
-        float lightLevel = (LightmapHelper.isLightmapEnabled() || this.mc.isFullbrightEnabled()) ? 1 : this.mc.currentWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
         float lightOffset = 0f;
         if (tileEntity.isGlowing()) {
-            lightLevel = 1f;
             lightOffset = 96f;
-            if (LightmapHelper.isLightmapEnabled()) {
-                LightmapHelper.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
-            }
+            GLRenderer.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
         }
 
-        GL11.glPushMatrix();
+        GLRenderer.pushFrame();
         final float scale2 = 0.2666667f * scale;
-        GL11.glTranslatef(0.0F, height * scale, 1.1f * scale);
-        GL11.glScalef(scale2, -scale2, scale2);
-        GL11.glDepthMask(false);
+        GLRenderer.modelM4f().translate(0.0F, height * scale, 1.1f * scale);
+        GLRenderer.modelM4f().scale(scale2, -scale2, scale2);
+        GLRenderer.setDepthMask(false);
         int color = Colors.allSignColors[tileEntity.getColor().id].getARGB();
-        final int r = (int) MathHelper.clamp((Color.redFromInt(color) * lightLevel + lightOffset), 0, 255);
-        final int g = (int) MathHelper.clamp((Color.greenFromInt(color) * lightLevel + lightOffset), 0, 255);
-        final int b = (int) MathHelper.clamp((Color.blueFromInt(color) * lightLevel + lightOffset), 0, 255);
+        final int r = (int) MathHelper.clamp((Color.redFromInt(color) + lightOffset), 0, 255);
+        final int g = (int) MathHelper.clamp((Color.greenFromInt(color) + lightOffset), 0, 255);
+        final int b = (int) MathHelper.clamp((Color.blueFromInt(color) + lightOffset), 0, 255);
         color = Color.intToIntARGB(0, r, g, b);
 
         CharSequence line1 = tileEntity.signText[0];
@@ -172,19 +159,19 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
         } else {
             this.textMeshRenderer.render(sr, t, line1, line2, line3, line4, _x, _y, SF.setColor(0, color));
         }
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
 
-        GL11.glDepthMask(true);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glPopMatrix();
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.setDepthMask(true);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.popFrame();
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
     private static void drawTexturedModalRect(final double width, final double height, final int color, final @NotNull IconCoordinate coordinate) {
         coordinate.parentAtlas.bind();
-        final Tessellator tessellator = Tessellator.instance;
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.setColorRGBA_I(color, 128);
+        tessellator.setColor2i(color, 128);
         tessellator.addVertexWithUV(-width / 2, height / 2, 0, coordinate.getIconUMin(), coordinate.getIconVMin());
         tessellator.addVertexWithUV(-width / 2, -height / 2, 0, coordinate.getIconUMin(), coordinate.getIconVMax());
         tessellator.addVertexWithUV(width / 2, -height / 2, 0, coordinate.getIconUMax(), coordinate.getIconVMax());
@@ -238,20 +225,20 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
         }
 
         public void render(@NotNull final FontRenderer sr,
-                           @NotNull final Tessellator t,
+                           @NotNull final TessellatorGeneral t,
                            @NotNull final CharSequence line1,
                            @NotNull final CharSequence line2,
                            @NotNull final CharSequence line3,
                            @NotNull final CharSequence line4,
                            final int x, final int y, final long config) {
-            GL11.glPushMatrix();
-            GL11.glTranslatef(x, y, 0);
+            GLRenderer.pushFrame();
+            GLRenderer.modelM4f().translate(x, y, 0);
             renderInternal(sr, t, line1, line2, line3, line4, config);
-            GL11.glPopMatrix();
+            GLRenderer.popFrame();
         }
 
-        private void renderInternal(@NotNull final FontRenderer sr,
-                                    @NotNull final Tessellator t,
+        private void renderInternal(@NotNull final FontRenderer sr, // TODO Rework text caching!
+                                    @NotNull final TessellatorGeneral t,
                                     @NotNull final CharSequence line1,
                                     @NotNull final CharSequence line2,
                                     @NotNull final CharSequence line3,
@@ -263,34 +250,34 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
             this.referenceEntry.line4 = line4.toString();
             this.referenceEntry.config = config;
 
-            MeshEntry entry = null;
-            final int size = this.bufferedMeshes.size();
-            for (int i = 0; i < size; i++) {
-                final MeshEntry e = this.bufferedMeshes.get(i);
-                if (this.referenceEntry.equals(e)) {
-                    entry = e;
-                    break;
-                }
-            }
-
-            if (entry != null) {
-                entry.lastUse = System.currentTimeMillis();
-                GL11.glCallList(entry.list);
-            } else {
-                entry = new MeshEntry(line1, line2, line3, line4, config);
-                entry.lastUse = System.currentTimeMillis();
-                entry.list = getDisplayList();
-
-                GL11.glNewList(entry.list, GL11.GL_COMPILE);
-                sr.render(t, line1, -sr.stringWidth(line1) / 2, 0).setConfig(config).call();
-                sr.render(t, line2, -sr.stringWidth(line2) / 2, 10).setConfig(config).call();
-                sr.render(t, line3, -sr.stringWidth(line3) / 2, 20).setConfig(config).call();
-                sr.render(t, line4, -sr.stringWidth(line4) / 2, 30).setConfig(config).call();
-                GL11.glEndList();
-                GL11.glCallList(entry.list);
-
-                this.bufferedMeshes.add(entry);
-            }
+//            MeshEntry entry = null;
+//            final int size = this.bufferedMeshes.size();
+//            for (int i = 0; i < size; i++) {
+//                final MeshEntry e = this.bufferedMeshes.get(i);
+//                if (this.referenceEntry.equals(e)) {
+//                    entry = e;
+//                    break;
+//                }
+//            }
+
+//            if (entry != null) {
+//                entry.lastUse = System.currentTimeMillis();
+//                GL11.glCallList(entry.list);
+//            } else {
+//                entry = new MeshEntry(line1, line2, line3, line4, config);
+//                entry.lastUse = System.currentTimeMillis();
+//                entry.list = getDisplayList();
+//
+//                GL11.glNewList(entry.list, GL11.GL_COMPILE);
+                sr.render(line1, -sr.stringWidth(line1) / 2, 0).setConfig(config).call();
+                sr.render(line2, -sr.stringWidth(line2) / 2, 10).setConfig(config).call();
+                sr.render(line3, -sr.stringWidth(line3) / 2, 20).setConfig(config).call();
+                sr.render(line4, -sr.stringWidth(line4) / 2, 30).setConfig(config).call();
+//                GL11.glEndList();
+//                GL11.glCallList(entry.list);
+//
+//                this.bufferedMeshes.add(entry);
+//            }
 
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
index 2c115e831..822ba11e4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
@@ -3,7 +3,10 @@ package net.minecraft.client.render.tileentity;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
@@ -12,11 +15,11 @@ import net.minecraft.core.entity.IArmorWearing;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.*;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Math;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
 import org.useless.dragonfly.DisplayPos;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
@@ -50,22 +53,22 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         }
     }
 
-    public void renderAt(@NotNull final Tessellator tessellator, @Nullable final ItemStack heldStack, final int meta, final @NotNull Block<?> lowerBlock, final @NotNull TileEntityStatue.Pose pose, final @Nullable IArmorWearing<HumanArmorShape> armorWearer, final double x, final double y, final double z) {
+    public void renderAt(@NotNull final TessellatorGeneral tessellator, @NotNull TileEntityStatue statue, @Nullable final ItemStack heldStack, final int meta, final @NotNull Block<?> lowerBlock, final @NotNull TileEntityStatue.Pose pose, final @Nullable IArmorWearing<HumanArmorShape> armorWearer, final double x, final double y, final double z) {
         final boolean isPigman = lowerBlock == Blocks.STATUE_PIGMAN_LOWER;
 
         final StaticEntityModel model = model(isPigman);
 
-        GL12.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+//        GL12.glEnable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         bindTexture(BLOCK_SKIN_MAP.getOrDefault(lowerBlock, BLOCK_SKIN_MAP.get(Blocks.STATUE_STONE_LOWER)));
-        GL11.glPushMatrix();
-        GL11.glTranslated(x + 0.5, y, z + 0.5);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) (x + 0.5f), (float) y, (float) (z + 0.5f));
         final float rotation = (float) (meta * 360) / 16F;
-        GL11.glRotatef(-rotation, 0.0F, 1.0F, 0.0F);
-        GL11.glDisable(GL11.GL_CULL_FACE);
+        GLRenderer.modelM4f().rotateY(Math.toRadians(-rotation));
+        GLRenderer.disableState(State.CULL_FACE);
 
-        GL11.glPushMatrix();
-        GL11.glScalef(1 / ENTITY_RENDER_SCALE, 1 / ENTITY_RENDER_SCALE, -1 / ENTITY_RENDER_SCALE);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().scale(1 / ENTITY_RENDER_SCALE, 1 / ENTITY_RENDER_SCALE, -1 / ENTITY_RENDER_SCALE);
         model.resetBones();
         renderModel(tessellator, model, pose);
         if (armorWearer != null) {
@@ -73,45 +76,46 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
                 renderArmor(tessellator, armorWearer, i, pose);
             }
         }
-        renderHeldItem(heldStack, isPigman);
-        GL11.glPopMatrix();
+        renderHeldItem(heldStack, Minecraft.getMinecraft().currentWorld.getLightmapCoord(new TilePos(statue.x, statue.y, statue.z), 0), isPigman);
+        GLRenderer.popFrame();
 
-        GL11.glEnable(GL11.GL_CULL_FACE);
-        GL11.glPopMatrix();
-        GL12.glDisable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.enableState(State.CULL_FACE);
+        GLRenderer.popFrame();
+//        GL12.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
-    private void renderHeldItem(final @Nullable ItemStack itemStack, final boolean isPigman) {
+    private void renderHeldItem(final @Nullable ItemStack itemStack, int lightmap, final boolean isPigman) {
         if (itemStack != null) {
-            GL12.glEnable(GL12.GL_RESCALE_NORMAL);
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+//            GL12.glEnable(GL12.GL_RESCALE_NORMAL);
+            GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             model(isPigman).translateToBone("rightItem");
-            GL11.glScalef(-1, 1, 1);
-            GL11.glScalef(ENTITY_RENDER_SCALE, ENTITY_RENDER_SCALE, ENTITY_RENDER_SCALE);
-            ItemModelDispatcher.getInstance().getDispatch(itemStack).render(Tessellator.instance, null, itemStack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1, 1f, 1f, 1f, false);
-            GL11.glEnable(GL11.GL_CULL_FACE);
-            GL12.glDisable(GL12.GL_RESCALE_NORMAL);
+            GLRenderer.modelM4f().scale(-1, 1, 1);
+            GLRenderer.modelM4f().scale(ENTITY_RENDER_SCALE, ENTITY_RENDER_SCALE, ENTITY_RENDER_SCALE);
+            ItemModelDispatcher.getInstance().getDispatch(itemStack).render(GLRenderer.getTessellator(), null, itemStack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1,
+               lightmap, 1f, false);
+            GLRenderer.enableState(State.CULL_FACE);
+//            GL12.glDisable(GL12.GL_RESCALE_NORMAL);
         }
     }
 
 
-    private void renderModel(@NotNull final Tessellator tessellator, @NotNull final StaticEntityModel model, @NotNull final TileEntityStatue.Pose pose) {
+    private void renderModel(@NotNull final TessellatorGeneral tessellator, @NotNull final StaticEntityModel model, @NotNull final TileEntityStatue.Pose pose) {
         model.getTransform("leftArm").rotX = pose.leftArmPitch;
         model.getTransform("rightArm").rotX = pose.rightArmPitch;
         model.getTransform("leftLeg").rotX = pose.leftLegPitch;
         model.getTransform("rightLeg").rotX = pose.rightLegPitch;
         model.getTransform("head").rotX = pose.headPitch;
         model.getTransform("head").rotY = pose.headYaw;
-        model.render(tessellator);
+        model.render();
     }
 
     @Override
-    public void doRender(@NotNull final Tessellator tessellator, @NotNull final TileEntityStatue tileEntity, final double x, final double y, final double z, final float partialTick) {
-        renderAt(tessellator, tileEntity.getHeldItem(), tileEntity.getBlockMeta(), tileEntity.getBlock(), tileEntity.getPose(), tileEntity, x, y, z);
+    public void doRender(@NotNull final TessellatorGeneral tessellator, @NotNull final TileEntityStatue tileEntity, final double x, final double y, final double z, final float partialTick) {
+        renderAt(tessellator, tileEntity, tileEntity.getHeldItem(), tileEntity.getBlockMeta(), tileEntity.getBlock(), tileEntity.getPose(), tileEntity, x, y, z);
         renderShadow(Minecraft.getMinecraft().currentWorld, tessellator, tileEntity.x, tileEntity.y, tileEntity.z, x, y, z, 2.0f, partialTick);
     }
 
-    private boolean renderArmor(final @NotNull Tessellator tessellator, final @NotNull IArmorWearing<? super HumanArmorShape> armorWearer, final int layer, final TileEntityStatue.@NotNull Pose pose) {
+    private boolean renderArmor(final @NotNull TessellatorGeneral tessellator, final @NotNull IArmorWearing<? super HumanArmorShape> armorWearer, final int layer, final TileEntityStatue.@NotNull Pose pose) {
         final ItemStack itemstack = armorWearer.getItemInArmorSlot(HumanArmorShape.values()[(armorWearer.getNumArmorSlots() - 1) - layer]);
         if (itemstack != null) {
             final Item item = itemstack.getItem();
@@ -170,14 +174,14 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         return false;
     }
 
-    private void renderShadow(final @NotNull World world, final @NotNull Tessellator tessellator, final int bx, final int by, final int bz, final double rx, final double ry, final double rz, final float opacity, final float partialTick) {
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+    private void renderShadow(final @NotNull World world, final @NotNull TessellatorGeneral tessellator, final int bx, final int by, final int bz, final double rx, final double ry, final double rz, final float opacity, final float partialTick) {
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         final TextureManager textureManager = this.renderDispatcher.textureManager;
         textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/misc/shadow.png"));
         final float shadowSize = 0.5f;
         final float shadowOffs = 0.8f / 2.0f;
-        GL11.glDepthMask(false);
+        GLRenderer.setDepthMask(false);
         tessellator.startDrawingQuads();
 
         final int blockId = world.getBlockId(bx, by - 1, bz);
@@ -186,12 +190,12 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         }
 
         tessellator.draw();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glDepthMask(true);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.setDepthMask(true);
     }
 
-    private void renderShadowOnBlock(final @NotNull World world, final @NotNull Tessellator tessellator, final @NotNull Block<?> block, final int bx, final int by, final int bz, final double rx, final double ry, final double rz,
+    private void renderShadowOnBlock(final @NotNull World world, final @NotNull TessellatorGeneral tessellator, final @NotNull Block<?> block, final int bx, final int by, final int bz, final double rx, final double ry, final double rz,
                                      final float opacity, final float size) {
         if (!block.isCubeShaped()) {
             return;
@@ -205,7 +209,7 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
         if (alpha > 1.0D) {
             alpha = 1.0D;
         }
-        tessellator.setColorRGBA_F(1.0F, 1.0F, 1.0F, (float) alpha);
+        tessellator.setColor4f(1.0F, 1.0F, 1.0F, (float) alpha);
         final AABBdc aabb = block.getCollisionBoundingBoxFromPool(world, bx, by - 1, bz);
         if (aabb == null) {
             return;
